﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.Json;
using System.Threading.Tasks;

namespace Network_01
{
    internal class Solution
    {

        public object MyProperty => new object();

        public static async Task CallAgifyAsync()
        {
            Console.WriteLine("Write name of person to predict age:");
            var name = Console.ReadLine();
            
            using var client = new HttpClient();
            var response = await client.GetAsync($"https://api.agify.io?name={name}");

            if (!response.IsSuccessStatusCode)
            {
                throw new Exception($"API call not successfull with error code {response.StatusCode}");
            }

            var responseAsString = await response.Content.ReadAsStringAsync();
            var serializedResponse = JsonSerializer.Deserialize<AgifyResponse>(responseAsString,
                new JsonSerializerOptions
                {
                    PropertyNameCaseInsensitive = true
                });

            Console.WriteLine($"Age of person {serializedResponse?.Name} will be {serializedResponse?.Age}");

        }
    }
}
