﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;

namespace SecurityDemo
{
    internal class MyPBKDF2
    {
        private static string hashedPassword = "";
        public static void HashPassword(string password, int iterations = 10000)
        {
            var salt = RandomNumberGenerator.GetBytes(24);

            using var function = new Rfc2898DeriveBytes(password, salt, iterations);
            var hash = function.GetBytes(24);
            hashedPassword = $"{Convert.ToBase64String(salt)}|{iterations}|{Convert.ToBase64String(hash)}";
        }

        public static bool Validate(string password)
        {
            var parts = hashedPassword.Split('|');

            var origSalt = Convert.FromBase64String(parts[0]);
            var origIterations = Int32.Parse(parts[1]);
            var origHash = parts[2];

            using var function = new Rfc2898DeriveBytes(password, origSalt, origIterations);
            var hash = function.GetBytes(24);
            return (Convert.ToBase64String(hash) == origHash);
        }
    }
}
