﻿using SecurityDemo;
using System.Diagnostics;
using System.Security.Cryptography;
using System.Text;

void RngNumberDemo()
{
    Console.WriteLine("Pseudorandom:");
    for(int i = 0; i < 10; i++)
    {
        Console.Write(MyRandom.GeneratePseudorandomNumber());
    };

    Console.WriteLine();
    Console.WriteLine("Random:");
    for (int i = 0; i < 10; i++)
    {
        Console.Write(MyRandom.GenerateRandomNumber());
    };
    Console.WriteLine();
}

RngNumberDemo();

void BasicHashing()
{
    // TODO
}

BasicHashing();

void HMACDemo()
{
    Console.WriteLine("HMAC");
    var key = RandomNumberGenerator.GetBytes(32);
    var hmac = MyHMAC.HMACSHA512(Encoding.UTF8.GetBytes("Ahoj"), key);

    Console.WriteLine(Convert.ToBase64String(hmac));
}

HMACDemo();

void PBKDF2Demo()
{
    Console.WriteLine("PBKDF2");
    MyPBKDF2.HashPassword("qwerty123");

    Console.WriteLine(MyPBKDF2.Validate("PV178FTW"));
    Console.WriteLine(MyPBKDF2.Validate("qwerty123"));
}

PBKDF2Demo();

void BenchmarkTask()
{
    // TODO
}

BenchmarkTask();

void AESDemo()
{
    var aes = new MyAES();
    var key = RandomNumberGenerator.GetBytes(32);
    var iv = RandomNumberGenerator.GetBytes(16);

    var encrypted = aes.Encrypt(Encoding.UTF8.GetBytes("allyourbasearebelongtous"), key, iv);

    Console.WriteLine(Convert.ToBase64String(encrypted));

    var decrypted = aes.Decrypt(encrypted, key, iv);

    Console.WriteLine(Encoding.UTF8.GetString(decrypted));
}

AESDemo();

void RSADemo()
{
    var rsa = new MyRSA();
    byte[] publicKey = rsa.ExportPublicKey();

    var rsa2 = new MyRSA();
    const string text = "The cake is a lie";
    rsa2.ImportPublicKey(publicKey);
    var encrypted = rsa2.Encrypt(text);

    var decrypted = rsa.Decrypt(encrypted);

    Console.WriteLine(Convert.ToBase64String(encrypted));
    Console.WriteLine(Encoding.UTF8.GetString(decrypted));
}

RSADemo();